function asccode(STRING,  chstr) {
	chstr = " !\"#$%&'()*+,-./0123456789:;<=>?"
	chstr = chstr "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_"
	chstr = chstr " abcdefghijklmnopqrstuvwxyz{|}~ "
	return index(chstr,STRING)+31
}

BEGIN {
	labelcnt = 1
	linecnt = 1
}

{

# Rg폜
	gsub(/'.*/,"'")

# r܂œxύX
	gsub(/GETD2/,"GET_D2")
	gsub(/N\.CODE2/,"N_CODE2")

# ϐQɂ
	gsub(/NFAD/,"NF")
	gsub(/FAD/,"FD")
	gsub(/EAD/,"ED")
	gsub(/PAGE\.NO/,"PG")
	gsub(/GDR/,"GR")
	gsub(/GNO/,"GN")
	gsub(/BGMM/,"BM")
	gsub(/BGMN/,"BN")
	gsub(/BGXX/,"BX")
	gsub(/GST/,"GS")
	gsub(/SST/,"SS")
	gsub(/WASA/,"WS")
	gsub(/MVA/,"VA")
	gsub(/MVE/,"VE")
	gsub(/MOB/,"OB")
	gsub(/VSB/,"SB")
	gsub(/VAR/,"AR")
	gsub(/PUX/,"UX")
	gsub(/COM\.TOP\.ADD/,"CD")
	gsub(/VSM/,"SM")
	gsub(/SELE\.LO/,"SL")
	gsub(/SELE\.P/,"SP")
	gsub(/SELE\.A/,"SA")
	gsub(/SELE\$/,"SL$")
	gsub(/POSE/,"PE")
	gsub(/SPOS/,"PS")
	gsub(/FRONT/,"FR")
	gsub(/ANS/,"AN")
	gsub(/VNO/,"VN")
	gsub(/ONO/,"OO")
	gsub(/NVA/,"NV")
	gsub(/DISK\(/,"DS(")
	gsub(/PDI/,"PD")
	gsub(/LNN/,"NN")
	gsub(/GDX/,"GX")
	gsub(/DUMMY/,"DM")
	gsub(/MAPA/,"MP")
	gsub(/NAM\$/,"NM$")
	gsub(/VX1/,"VX")
	gsub(/VY1/,"VY")

# R}h̕ύXȂ
	gsub(/WRITE/,"PRINT")
	gsub(/POLL/,"VIEW")
	gsub(/COLOR */,"&9+")
	gsub(/STATUS SET */,"WINDOW #")
	gsub(/STATUS CALL */,"WINDOW ")
	gsub(/STATUS\(/,"WINDOW(")
	gsub(/CLS *3/,"CLS")
	gsub(/DEFINT *A-Z:*/,"")

# &H8000` ̏
	gsub(/&H[8-9A-F][0-9A-F][0-9A-F][0-9A-F]/,"&+65536")

# LINȄ
	while (match($0,/LINE/) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART)
		sub(/LINE/,"@@LNDMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,",9+",ln2)
		gsub(/@@DUMMY@@/,"/2,",ln2)
		$0 = ln1 ln2
	}
	gsub(/@@LNDMY@@/,"LINE")

# PAINT̏
	while (match($0,/PAINT/) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART)
		sub(/PAINT/,"@@PNDMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,"@@CLDMY@@",ln2)
		sub(/,/,"@@CLDMY@@",ln2)
		gsub(/@@DUMMY@@/,"/2,",ln2)
		gsub(/@@CLDMY@@/,",9+",ln2)
		$0 = ln1 ln2
	}
	gsub(/@@PNDMY@@/,"PAINT")

# LOCATȄ
	while (match($0,/LOCATE */) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART+RLENGTH)

		lne = match(ln2,/:/)
		lnc = match(ln2,/,/)
		if (lnc == 0 || (lne != 0 && lnc > lne) ) {
			if (match(ln2,/:/) != 0) {
				lnx = substr(ln2,1,RSTART-1)
				ln2 = substr(ln2,RSTART)
			} else {
				lnx = ln2
				ln2 = ""
			}
			lny = "CSRLIN"
		} else {
			match(ln2,/,/)
			lnx = substr(ln2,1,RSTART-1)
			ln2 = substr(ln2,RSTART+RLENGTH)
			if (match(ln2,/:/) != 0) {
				lny = substr(ln2,1,RSTART-1)
				ln2 = substr(ln2,RSTART)
			} else {
				lny = ln2
				ln2 = ""
			}
		}
		$0 = ln1 "ZX=" lnx ":ZY=" lny ":GOSUB 20000" ln2
	}


# RETURN sԍ̏
	gsub(/GOSUB *\*BETA\.OUT/,"&:ON RR GOTO 50,6000,20")
	gsub(/RETURN *50/,"RR=1:RETURN")
	gsub(/RETURN *\*LOAD\./,"RR=2:RETURN")
	gsub(/RETURN *\*MAIN\.LOOP/,"RR=3:RETURN")
	if ($1 == "4010") {
		gsub(/RETURN/,"RR=0:RETURN")
	}


# ʕύX
	gsub(/SWAP UP,GD/,"XX=UP:UP=GD:GD=XX")

	if ($1 == 40) {
		sub(/CVI\(CHR\$\(WINDOW\(0\)\)\+CHR\$\(WINDOW\(1\)\)\)/,"WINDOW(0)+256*WINDOW(1)")
	}
	if ($1 == 100) {
		sub(/MATA.*:/,"")
	}
	if ($1 == 110) {
		sub(/CALL MATA\(/,"CMD MA,4,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 380) {
		sub(/CALI.*:/,"")
		sub(/CALL CALI\(/,"CMD CA,5,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 450) {
		sub(/EPASS.*:/,"")
		sub(/CALL EPASS\(/,"CMD EP,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 >= 470 && $1 <= 630 || $1 == 650 || $1 == 670) {
		sub(/GD\$/,"GD")
		match($0,/"."/)
		asc = sprintf("\\&H%02X",asccode( substr($0,RSTART+1,1) ) )
		sub(/"."/,asc)
	}
	if ($1 == 620 || $1 == 640) {
		gsub(/A\$/,"A")
		gsub(/GD\$/,"GD")
		sub(/CVI\(A\+GD\)/,"A+256*GD")
	}
	if ($1 == 700) {
		sub(/PYY=CSRLIN:/,"")
	}
	if ($1 == 710) {
		$0 = $1 " GOSUB 21000"
	}
	if ($1 == 790) {
		sub(/KAKKO.*:CALL/,"CALL")
		sub(/CALL KAKKO\(/,"CMD KA,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 830) {
		sub(/:GD\$.*/,"")
	}
	if ($1 == 860 || $1 == 870) {
		sub(/GD\$/,"CHR$(GD)")
	}
	if ($1 == "905") {
		sub(/ /," EXEC \\&H0123:")
	}
	if ($1 == "980") {
		$0 = $1 " PK=KEY(0):XX=RND(1)"
	}
	if ($1 == "990") {
		sub(/IF PK AND 1/,"IF PK=30")
	}
	if ($1 == "1000") {
		sub(/IF PK AND 2/,"IF PK=31")
	}
	if ($1 == "1010") {
		sub(/IF PK AND 8/,"IF PK=28")
	}
	if ($1 == "1020") {
		sub(/IF PK AND 4/,"IF PK=29")
	}
	if ($1 == "1030") {
		sub(/IF PK AND 16/,"IF PK=13 OR PK=32")
		sub(/WHILE.*WEND:/,"")
		sub(/RETURN:.*/,"RETURN")
	}
	if ($1 == "1031") {
		gsub(/IF PK AND 32/,"IF PK=27")
	}
	if ($1 >= 1120 && $1 <= 1180) {
		$0 = $1 " REM"
	}
	if ($1 == 2830) {
		$0 = $1 " IF KEY(0)<>0 THEN 2830"
	}
	if ($1 == 2832) {
		$0 = $1 " IF KEY(0)=0 THEN 2832"
	}
	if ($1 == 2850) {
		sub(/POKE.*&HC9:/,"")
	}
	if ($1 == 2860) {
		sub(/ /," WINDOW #1:")
	}
	if ($1 == 3010) {
		sub(/GS\(GD-1\)\\255/,"INT(GS(GD-1)/256)")
	}
	if ($1 == 3055) {
		gsub(/BEEP/,"PRINT CHR$(7)")
	}
	if ($1 == 3090) {
		sub(/RBYTE/,"GOSUB 22000:OPEN")
		sub(/COLOR.*/,"FOR INPUT AS#2:WINDOW #2:WINDOW GN:SET 9+UP:CLOSE #2")
	}
	if ($1 == 3100) {
		sub(/$/,":GOSUB 15000")
	}
	if ($1 == 5001) {
		$0 = $1 " REM"
	}
	if ($1 == 5010) {
		$0 = $1 " CLEAR 50,&HB000"
	}
	if ($1 == 5020) {
		$0 = $1 " EP=&HD706:CA=&HD108:KA=&HD102:MA=&HD105:SE=&HD70B"
	}
	if ($1 == 5030) {
		$0 = $1 " ON ERROR GOTO 60000"
	}
	if ($1 == 5035 || $1 == 5050) {
		$0 = $1 " REM"
	}
	if ($1 == 5040) {
		$0 = $1 " WS=PEEK(&HD100)+256*PEEK(&HD101)"
	}
	if ($1 == 5051) {
		sub(/BM=1:/,"")
		sub(/:POKE.*/,"")
	}
	if ($1 == 5060) {
		sub(/:WLOAD.*/,"")
	}
	if ($1 == 5110) {
		sub(/GS\(255\)/,"GS(152)")
	}
	if ($1 == 5160) {
		sub(/:PDH.*/,"")
	}
	if ($1 == 5170) {
		sub(/GET/,"WINDOW ")
		sub(/,2$/,":WINDOW 0")
	}
	if ($1 == 5171) {
		sub(/255/,"152")
		sub(/CVI\(INPUT\$\(2,2\)\)/,"WINDOW(I*2)+256*WINDOW(I*2+1)")
	}
	if ($1 == 5180) {
		sub(/$/,":WINDOW 0")
	}
	if ($1 == 5185) {
		sub(/CLS 2/,"CLS")
	}
	if ($1 == 6560) {
		sub(/POKE.*&HC3:/,"")
		sub(/:POKE.*&HC9/,"")
	}
	if ($1 == 6570) {
		gsub(/$/,":WINDOW NN:DM=WINDOW(0)")
	}
	if ($1 == 6600) {
		gsub(/$/,":EXEC \\&H0123")
	}
	if ($1 == 6610) {
		$0 = $1 " PK=KEY(0):XX=RND(1)"
	}
	if ($1 == 6620) {
		sub(/IF PK AND 1/,"IF PK=30")
	}
	if ($1 == 6630) {
		sub(/IF PK AND 2/,"IF PK=31")
	}
	if ($1 == 6640) {
		sub(/IF PK AND 16/,"IF PK=13 OR PK=32")
		sub(/ESCM=0:/,"")
	}
	if ($1 == 6641) {
		$0 = $1 " REM"
	}
	if ($1 == 8100) {
		sub(/CLS 2/,"CLS")
	}
	if ($1 == 9020) {
		sub(/VX/,"VV")
	}
	if ($1 == 9050) {
		sub(/$/,":VV=VX")
	}
	if ($1 == 30020) {
		$0 = $1 " EXEC &HDF09"
	}
	if ($1 == 30050) {
		$0 = $1 " EXEC &HDF03:EXEC &HDF06"
	}
	if ($1 == 60001 || $1 == 60010) {
		$0 = $1 " REM"
	}


# x̋LƃRgAEg
	if ( substr($2,1,1) == "*") {
		match($0,/ /)
		tmp1 = substr($0,RSTART+2)
		if ( match(tmp1,/:/) == 0) {
			tmp2 = "'"
			tmp3 = tmp1
		} else {
			tmp2 = substr(tmp1,RSTART+1)
			tmp3 = substr(tmp1,1,RSTART-1)
		}
		$0 = $1 " "tmp2
		gsub(/\./,"\\.",tmp3)
		label[labelcnt] = "\\*" tmp3
		labelnum[labelcnt] = $1
		labelcnt ++
	}


	linebuf[linecnt] = $0
	linecnt ++

}

END {
	wflag = 0
	for (i = 1;i < linecnt;) {
		for (j = 1;j < labelcnt;j ++) {
			gsub(label[j],labelnum[j],linebuf[i])
		}

# WHILE - WEND 

		match(linebuf[i+1],/[^0-9 ]/)
		n_num = substr(linebuf[i+1],1,RSTART-1)

		match(linebuf[i]  ,/[^0-9 ]/)
		c_num = substr(linebuf[i],1,RSTART-1)
		c_line = substr(linebuf[i],RSTART)

		c_if = match(c_line,/IF/)
		c_wl = match(c_line,/WHILE/)
		c_wd = match(c_line,/WEND/)

		match(c_line,/[ :]*WHILE/)
		c_b_wl = substr(c_line,1,RSTART-1)

		match(c_line,/WHILE */)
		c_x_wl = substr(c_line,RSTART+RLENGTH)
		if (match(c_x_wl,/ *:/) != 0) {
			c_x_wl = substr(c_x_wl,1,RSTART-1)
		}

		if (match(c_line,/WHILE *[^:]*:/) == 0) {
			c_e_wl = ""
		} else {
			c_e_wl = substr(c_line,RSTART+RLENGTH)
		}

		match(c_line,/WHILE *[^:]*:/)
		c_m_wl = substr(c_line,RSTART+RLENGTH)
		match(c_m_wl,/[ :]*WEND/)
		c_m_wl = substr(c_m_wl,1,RSTART-1)

		match(c_line,/[ :]*WEND[ :]*/)
		c_e_wd = substr(c_line,RSTART+RLENGTH)

		match(c_line,/[ :]*WEND/)
		c_b_wd = substr(c_line,1,RSTART-1)


		if (c_wl != 0) {
			if (c_if != 0 && c_if < c_wl) {
				print "Error!! IF before WHILE"
				print linebuf[i]
			} else {
				if (c_wd != 0) {
					if (n_num-c_num < 5) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {
						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wd == "") {
							c_e_wd = "'"
						}
						print c_num+0 " " c_b_wl
						print c_num+1 " " "IF " c_x_wl " THEN " c_num+3
						print c_num+2 " " "GOTO " c_num+4
						print c_num+3 " " c_m_wl ":GOTO " c_num+1
						print c_num+4 " " c_e_wd
					}
				} else {

					wflag = c_num+1
					if (n_num-c_num < 4) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {

						w_num = c_num

						i ++
						for (j = 1;c_wd == 0;j++) {
							wbuf[j] = linebuf[i]
							c_wd = match(wbuf[j],/WEND/)
							i ++
						}
						j --
						i --

						match(linebuf[i+1],/[^0-9 ]/)
						n_num = substr(linebuf[i+1],1,RSTART-1)

						match(linebuf[i]  ,/[^0-9 ]/)
						c_num = substr(linebuf[i],1,RSTART-1)
						c_line = substr(linebuf[i],RSTART)


						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wl == "") {
							c_e_wl = "'"
						}
						print w_num+0 " " c_b_wl
						print w_num+1 " " "IF " c_x_wl " THEN " w_num+3
						print w_num+2 " " "GOTO " c_num+1
						print w_num+3 " " c_e_wl

						for (k = 1;k < j;k ++) {
							print wbuf[k]
						}

						match(c_line,/[ :]*WEND[ :]*/)
						c_e_wd = substr(c_line,RSTART+RLENGTH)

						match(c_line,/[ :]*WEND/)
						c_b_wd = substr(c_line,1,RSTART-1)

						if (n_num-c_num < 2) {
							print "Error!! LineNumber"
							print wbuf[j]
							print wbuf[j+1]
						} else {
							if (c_e_wd == "") {
								c_e_wd = "'"
							}
							print c_num+0 " " c_b_wd ":GOTO " wflag
							print c_num+1 " " c_e_wd
							wflag = 0
						}

					}

				}
			}

		} else {
			print linebuf[i]
		}

		if (match(linebuf[i],/^5010 /) != 0) {
			print "5011 BLOAD \"2:MSK1\":POKE &HD398,&H00:POKE &HD399,&H20:EXEC &HD383"
			print "5012 BLOAD \"2:MSK2\":POKE &HD398,&H20:POKE &HD399,&H20:EXEC &HD383"
			print "5013 IF PEEK(&HDFFF)=0 THEN BLOAD \"2:MSK3\",&HB900:BLOAD \"2:MSK4\",&HF000:GOTO 5016"
			print "5014 BLOAD \"2:MSK3\":POKE &HD398,&H40:POKE &HD399,&H17:EXEC &HD383"
			print "5015 BLOAD \"2:MSK4\":POKE &HD398,&H57:POKE &HD399,&H10:EXEC &HD383"
			print "5016 CLEAR 2000,&HB900:BM=PEEK(&HDFFD)"
		}

		if (match(linebuf[i],/^10060 /) != 0) {
			print "15000 IF GD=42 THEN GOSUB 15600:GOTO 15030"
			print "15010 IF GD<103 OR GD>107 THEN RETURN"
			print "15020 VV=0:ON GD-102 GOSUB 15100,15200,15300,15400,15500"
			print "15030 READ ZX,ZY,ZC:IF ZX=-1 THEN RETURN"
			print "15040 PSET(ZX,ZY),ZC:GOTO 15030"
			print "15100 RESTORE 15110:RETURN"
			print "15110 DATA70,9,9,153,46,9,84,104,9,84,106,9,105,23,13"
			print "15120 DATA85,108,13,85,109,13,84,109,13,60,30,13,-1,-1,-1"
			print "15200 RESTORE 15210:RETURN"
			print "15210 DATA138,12,13,139,12,9,122,128,13,120,129,13,120,128,9"
			print "15220 DATA26,98,13,27,98,9,27,99,13,90,34,13,139,122,9,-1,-1,-1"
			print "15300 RESTORE 15310:RETURN"
			print "15310 DATA162,106,13,-1,-1,-1"
			print "15400 RESTORE 15410:RETURN"
			print "15410 DATA52,47,13,50,42,13,49,42,9,21,76,9,152,83,13,152,95,13"
			print "15420 DATA134,33,9,171,33,9,141,11,13,141,12,13,142,11,9,142,12,9,-1,-1,-1"
			print "15500 RESTORE 15510:RETURN"
			print "15510 DATA26,61,9,11,62,9,11,63,9,11,64,9,98,123,9,-1,-1,-1"
			print "15600 RESTORE 15610:RETURN"
			print "15610 DATA270,168,14,270,170,14,270,172,14,274,170,14,274,177,14"
			print "15620 DATA283,168,14,283,170,14,283,172,14,286,168,14,286,170,14,286,172,14"
			print "15630 DATA289,168,14,289,170,14,289,172,14,296,168,14,296,172,14,-1,-1,-1"
			print "20000 POKE &HEC7C,2:POKE &HECA0,80:LOCATE ZX,ZY:POKE &HEC7C,1:POKE &HECA0,40:RETURN"
			print "21000 EXEC &H0123"
			print "21010 XX=RND(1):IF KEY(0)=0 THEN 21010"
			print "21020 XX=RND(1):IF KEY(0)<>0 THEN 21020"
			print "21030 RETURN"
			print "22000 IF PEEK(&HDFFE)=0 THEN RETURN"
			print "22010 CHAIN 2,\"RANCEP6\"+CHR$(64+GR):RETURN"

		}

		if (match(linebuf[i],/^60010 /) != 0) {
			print "60050 SCREEN 2,2,2:CONSOLE 0,20,0,0"
			print "60051 CLS:PRINT:COLOR 16"
			print "60052 VIEW\"G[ԍF\":VIEW STR$(ERR):VIEW STR$(ERL):PRINT"
			print "60055 GOTO 60055"
		}

		i ++

	}

}
