/****************************************************/
/* Doubl Two DOS to file                            */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN		16
#define	SECLEN		0x400
#define	MAXSEC		5
#define	MAXTRACK	80
#define	TRACKBYTE	0x1600
#define	FILEOFFSET	0x1600
#define	CLASTERSIZE	0x0b00
#define	CLOFFSET	0x2a00

/*
track0x00:C=00 H=00 R=01 N=01=0x100 0x0002b0
track0x00:C=00 H=00 R=0e N=01=0x100 0x0003b0
track0x00:C=00 H=00 R=0b N=01=0x100 0x0004c0
track0x00:C=00 H=00 R=08 N=01=0x100 0x0005d0
track0x00:C=00 H=00 R=05 N=01=0x100 0x0006e0
track0x00:C=00 H=00 R=02 N=01=0x100 0x0007f0
track0x00:C=00 H=00 R=0f N=01=0x100 0x000900
track0x00:C=00 H=00 R=0c N=01=0x100 0x000a10
track0x00:C=00 H=00 R=09 N=01=0x100 0x000b20
track0x00:C=00 H=00 R=06 N=01=0x100 0x000c30
track0x00:C=00 H=00 R=03 N=01=0x100 0x000d40
track0x00:C=00 H=00 R=10 N=01=0x100 0x000e50
track0x00:C=00 H=00 R=0d N=01=0x100 0x000f60
track0x00:C=00 H=00 R=0a N=01=0x100 0x001070
track0x00:C=00 H=00 R=07 N=01=0x100 0x001180
track0x00:C=00 H=00 R=04 N=01=0x100 0x001290


track0x00:C=00 H=01 R=01 N=03=0x400 0x0013a0
track0x00:C=00 H=01 R=04 N=03=0x400 0x0017b0
track0x00:C=00 H=01 R=02 N=03=0x400 0x001bc0
track0x00:C=00 H=01 R=05 N=03=0x400 0x001fd0
track0x00:C=00 H=01 R=03 N=03=0x400 0x0023e0
track0x00:C=00 H=01 R=06 N=02=0x200 0x0027f0

track0x01:C=01 H=00 R=01 N=03=0x400 0x002a00
track0x01:C=01 H=00 R=04 N=03=0x400 0x002e10
track0x01:C=01 H=00 R=02 N=03=0x400 0x003220
track0x01:C=01 H=00 R=05 N=03=0x400 0x003630
track0x01:C=01 H=00 R=03 N=03=0x400 0x003a40
track0x01:C=01 H=00 R=06 N=02=0x200 0x003e50
  :
  :
  :
track0x4F:C=27 H=01 R=01 N=03=0x400 0x06e4e0
track0x4F:C=27 H=01 R=04 N=03=0x400 0x06e8f0
track0x4F:C=27 H=01 R=02 N=03=0x400 0x06ed00
track0x4F:C=27 H=01 R=05 N=03=0x400 0x06f110
track0x4F:C=27 H=01 R=03 N=03=0x400 0x06f520
track0x4F:C=27 H=01 R=06 N=02=0x200 0x06f930
*/

/*
f[^̏Ԃ́AȐԒʂiC^[[uj

PNX^PPZN^i0x100~11j
PgbNQQZN^QNX^

C=XXAH=XXAR=01AN=01́ABASICł͎gpȂiu[gpj

NX^́A擪珇ԂɔԍU

gbN0x00NX^0x00ANX^0x01îݓj
gbN0x01NX^0x02ANX^0x03
gbN0x02NX^0x04ANX^0x05
 :

NX^0x02A0x03́ABASICVXeŎgpB
iFILELISTAFATj

*/

int main(int argc, char **argv)
{
	unsigned char	diskimg[MAXTRACK*TRACKBYTE];
	char	outbody[S_LEN],outext[S_LEN],outfile[S_LEN];
	FILE	*infp, *outfp;
	int		num,c,i,j,k,secno;
	int		fileno,fileptr;
	int		flag;
	int		claster,clsize,nextcl;
	int		a0,a1,a2,a3;

	if (argc != 2) {
		fprintf(stderr, "Usage: d88file infile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	fseek(infp,0x20,SEEK_SET);

	a0 = fgetc(infp);
	a1 = fgetc(infp);
	a2 = fgetc(infp);
	a3 = fgetc(infp);

	fseek(infp,a3*0x1000000+a2*0x10000+a1*0x100+a0,SEEK_SET);


	for (i = 0;i < 1;i ++) {
		for (j = 0;j < 16;j ++) {
			for (k = 0;k < 16;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
			}
			for (k = 0;k < 0x100;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
			}
		}
	}

	for (;i < MAXTRACK;i ++) {

		for (j = 0;j < MAXSEC;j ++) {

			switch (j) {
				case 0:
					secno = 1; break;
				case 1:
					secno = 4; break;
				case 2:
					secno = 2; break;
				case 3:
					secno = 5; break;
				case 4:
					secno = 3; break;
				default:
					secno = 6; break;
			}

			for (k = 0;k < 16;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
			}
			for (k = 0;k < SECLEN;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
				diskimg[i*TRACKBYTE+(secno-1)*SECLEN+k] = (unsigned char)c;
			}
		}

		/* UZN^ */
		for (k = 0;k < 16;k ++) {
			if ((c = fgetc(infp)) == EOF) {
				printf("Data illigal\n");
				exit(1);
			}
		}
		for (k = 0;k < 0x200;k ++) {
			if ((c = fgetc(infp)) == EOF) {
				printf("Data illigal\n");
				exit(1);
			}
			diskimg[i*TRACKBYTE+(6-1)*SECLEN+k] = (unsigned char)c;
		}

	}


/* file generate */

	fileno = 0;

	for (;;) {
		fileptr = fileno * 0x10 + FILEOFFSET;
		c = diskimg[fileptr];
		flag = (0x21 <= c) ? 1 : 0;
		if (c == 0xff) {
			break;
		}
		if (fileno == 0x40) {
			break;
		}
		if (flag == 0) {
			fileno ++;
			continue;
		}

		for (i = 0;i < 6;i ++) {
			outbody[i] = diskimg[fileptr + i];
		}
		for (i = 0;i < 3;i ++) {
			outext[i]  = diskimg[fileptr + 6 + i];
		}

		for (i = 0,j = 0;i < 6;i ++,j++) {
			c = outbody[i];
			if (c == 0x20) {
				break;
			}
			outfile[j] = c;
		}

		if (outext[0] != 0x20) {

			outfile[j] = '.';
			j ++;

			for (i = 0;i < 3;i ++,j++) {
				c = outext[i];
				if (c == 0x20) {
					break;
				}
				outfile[j] = c;
			}
		}
		outfile[j] = 0x00;
		printf("Generate file : %s\n",outfile);

		if ((outfp = fopen(outfile, "wb")) == NULL) {
			perror(outfile);
			exit(1);
		}

		claster = diskimg[fileptr + 10];

		for (;;) {

			nextcl = diskimg[claster + CLOFFSET];

			if (nextcl == 0xff || nextcl == 0xfe) {
				break;
			}

			/* NX^TCYZo */

			clsize = CLASTERSIZE;
			if ((nextcl & 0xf0) == 0xc0) {
				clsize = 0x100 * (nextcl & 0x0f);
			}

			for (i = 0;i < clsize;i ++ ) {
				fputc(diskimg[claster * CLASTERSIZE + i],outfp);
			}

			if ((nextcl & 0xf0) == 0xc0) {
				break;
			}
			claster = nextcl;
		}

		fclose(outfp);
		fileno ++;

	}


	fclose(infp);


	return(0);
}
